routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('crud', 'CrudsController');

Route::get('/create','CreateController@index')->name('create');
Route::get('/welcome','HomeController@welcome')->name('welcome');



Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/profile', 'HomeController@profile')->name('profile');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

/*Route::group([‘middleware’ => ‘App\Http\Middleware\AdminMiddleware’], function()
{
Route::match([‘get’, ‘post’], ‘/adminOnlyPage/’, "HomeController@admin");
});

Route::group([‘middleware’ => ‘App\Http\Middleware\StudentMiddleware’], function()
{
Route::match([‘get’, ‘post’], ‘/studentOnlyPage/’, "HomeController@member");
});*/

app/Crud.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Crud extends Model
{
    protected $table= "sample_data";
    protected $fillable = ['first_name', 'last_name' , 'image'];
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email','role', 'password', 
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/CreateController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class CreateController extends Controller
{
    public function index()
    {
        return view('create');
    }
}

app/Http/Controllers/CrudsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Crud;

class CrudsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    protected $table = 'testing';
    public function index()
    {
        $data= Crud::latest()->paginate(5);
        return view('index', compact('data'))
        -> with ('i', (request()->input('page',1)-1) * 5);
    
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
         //validate
        $request->validate ( [
            'first_name'  => 'required',
            'last_name'   => 'required',
            'image'       => 'required|image|max:2048'

        ]);
        
        $image = $request->file('image');
        $new_name = rand() . '.'. $image->getClientOriginalExtension();
        $image->move(public_path('images'), $new_name);
        $form_data = array(
            'first_name'  => $request->first_name,
            'last_name'   => $request->last_name,
            'image'       => $new_name

        );
        Crud::create($form_data);
        /*Crud::create ([
                'first_name' => $form_data['first_name'],
                'last_name' => $form_data['last_name'],
                'image' => $form_data['image']
            ]);
        */
        return redirect('crud')->with('success', 'Data Added successfully.');


    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
    public function admin(Request $req){
        return view('middleware')->withMessage('Admin');
    }

    public function welcome(Request $req){
        return view('welcome');
    }

    public function profile(Request $req){
        return view('profile');
    }
        
    public function student(Request $req){
        return view('middleware')->withMessage('Student');
    }
}

resources/views/create.blade.php
@extends('parent')

@section('main')
@if($errors->any())

<div class="alert alert-danger">
    <ul>
        @foreach ($errors->all() as $error)
        <li> {{ $error }} </li>
        @endforeach

    </ul>
</div>
@endif

<div align="right">
    <a href="{{ route('crud.index')}}"> Back </a>
</div>


<form method="post" action="{{ route('crud.store')}}" enctype="multipart/form-data">
    @csrf
    <div>
    <label> Enter First Name </label>
        <div>
            <input type="text" name="first_name" />
        </div>
    </div>

    <br/>
    <br/>

    <div>
    <label> Enter Last Name </label>
        <div>
            <input type="text" name="last_name" />
        </div>
    </div>

    <br/>
    <br/>
    
    <div>
        <input type="file" name="image" />  
    </div>

    <br/>
    <div>
        <input type="submit" name="add" />  
    </div>

</form>
    
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
        <div class="panel panel-default">
        <div class="panel-heading">Dashboard</div>
        <div class="panel-body">
        You are logged in! as <strong>{{ strtoupper(Auth::user()->role) }}</strong>
        Admin Page: <a href="{{ url('/') }}/adminOnlyPage">{{ url('/') }}/adminOnlyPage</a>
        Member Page: <a href="{{ url('/') }}/studentOnlyPage">{{ url('/') }}/memberOnlyPage</a>
        </div>
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Dashboard
                <a href="{{ url('/welcome') }}">back</a>
                </div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    You are logged in!
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/index.blade.php
@extends('parent')

@section('main')

<div align="right">
    <a href="{{ route('crud.create')}}"> Add </a>
</div>
<div align="left">
<a href="{{ url('/welcome') }}">back</a>
</div>


@if($message = Session::get('success'))
<div class="alert alert-success">
    <p>{{ $message }}</p>
</div>
@endif





<table class="table table-bordered table-striped">
    <tr>
        <th width="10%"> Image </th>
        <th width="35%"> First Name </th>
        <th width="35%"> Last Name </th>
        <th width="30%"> Action </th>
    </tr>
    @foreach($data as $row)
    <tr>
        <td><img src="{{ URL::to('/')}}images/{{ $row->image }}" class="img-thumbnail" width="75"/></td>
        <td>{{ $row->first_name }}</td>
        <td>{{ $row->last_name }}</td>
        <td>
            <p>buttons</p>
        </td>

    </tr>

    @endforeach
</table>
{!! $data->links()!!}
@endsection

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/middleware.blade.php
<div class=”title m-b-md”>
{{ strtoupper($message)}} only page!
</div>

resources/views/parent.blade.php
<html>
<head>
    <meta name="viewport" content="width=device-width,initial-scale=1"/>
    <title> Tester Project </title>
    <meta name="viewport" content="width=device-width,initial-scale=1,maximum-scale=1"/>
    <script>src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/css/bootstrap.min.css">

</head>

<body>
    <div class="container">
        <br/>
        <h3 align="center" > Tester Project CRUD </h3>
        <br />
        @yield('main')
    </div>
</body>

</html>

resources/views/profile.blade.php
@extends('layouts.app')

@section('content')



<div >
<a href="{{ url('/welcome') }}" style="margin-left:10%;">back</a>
</div>

<div class="container">
    <div class="panel panel-default">
        <div class="panel-heading" style="margin-left:46%;"> Welcome </div>
        <div class="panel-body" style="margin-left: 25%; background-color:pink; padding: 10%; width: 50%;">
            
            <tr>
                <td> <p> Role: <strong>{{ Auth::user()->role }}</strong> </p></td>
                <td><p> name: <strong>{{ Auth::user()->name }}</strong></p> </td>
                <td><p> Email: <strong>{{ Auth::user()->email }}</strong></p> </td>
            </tr>
        
        
        </div>
    </div>
</div>

@endsection

resources/views/unauthorized.blade.php
<div class=”title m-b-md”>
You cannot access this page! This is for only ‘{{$role}}’”
</div>